Index: NEMO/branches/UKMO/NEMO_4.0_surge/src/OCE/ZDF/zdfphy.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_surge/src/OCE/ZDF/zdfphy.F90	(revision 11145)
+++ NEMO/branches/UKMO/NEMO_4.0_surge/src/OCE/ZDF/zdfphy.F90	(revision 11180)
@@ -84,4 +84,6 @@
       !!----------------------------------------------------------------------
       !
+      IF( .NOT. ln_2d ) THEN
+
       IF(lwp) THEN
          WRITE(numout,*)
@@ -209,4 +211,6 @@
       IF( ln_zdfswm )   CALL zdf_swm_init       ! surface  wave-driven mixing
 
+      ENDIF  ! .NOT. ln_2d
+
       !                          !== top/bottom friction  ==!
       CALL zdf_drg_init
@@ -251,4 +255,6 @@
          ENDIF
       ENDIF
+      
+      IF( .NOT. ln_2d ) THEN ! 2D case only uses bottom friction from this routine     
       !
       !                       !==  Kz from chosen turbulent closure  ==!   (avm_k, avt_k)
@@ -321,4 +327,6 @@
          ! NB. OSMOSIS restart (osm_rst) will be called in step.F90 after wn has been updated
       ENDIF
+      
+      ENDIF  ! .NOT. ln_2d
       !
       IF( ln_timing )   CALL timing_stop('zdf_phy')
Index: NEMO/branches/UKMO/NEMO_4.0_surge/src/OCE/nemogcm.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_surge/src/OCE/nemogcm.F90	(revision 11145)
+++ NEMO/branches/UKMO/NEMO_4.0_surge/src/OCE/nemogcm.F90	(revision 11180)
@@ -75,4 +75,5 @@
    USE sbc_oce , ONLY : lk_oasis
    USE wet_dry        ! Wetting and drying setting   (wad_init routine)
+   USE dom_oce , ONLY : ln_2d 
 #if defined key_top
    USE trcini         ! passive tracer initialisation
@@ -446,15 +447,17 @@
                                      
       !                                         ! Lateral physics
-                           CALL ldf_tra_init      ! Lateral ocean tracer physics
+      IF (.NOT. ln_2d)     CALL ldf_tra_init      ! Lateral ocean tracer physics
                            CALL ldf_eiv_init      ! eddy induced velocity param.
                            CALL ldf_dyn_init      ! Lateral ocean momentum physics
 
       !                                      ! Active tracers
-      IF( ln_traqsr    )   CALL tra_qsr_init      ! penetrative solar radiation qsr
-                           CALL tra_bbc_init      ! bottom heat flux
-                           CALL tra_bbl_init      ! advective (and/or diffusive) bottom boundary layer scheme
-                           CALL tra_dmp_init      ! internal tracer damping
-                           CALL tra_adv_init      ! horizontal & vertical advection
-                           CALL tra_ldf_init      ! lateral mixing
+      IF (.NOT. ln_2d) THEN  ! No tracers in 2D mode 
+          IF( ln_traqsr    )   CALL tra_qsr_init      ! penetrative solar radiation qsr
+                               CALL tra_bbc_init      ! bottom heat flux
+                               CALL tra_bbl_init      ! advective (and/or diffusive) bottom boundary layer scheme
+                               CALL tra_dmp_init      ! internal tracer damping
+                               CALL tra_adv_init      ! horizontal & vertical advection
+                               CALL tra_ldf_init      ! lateral mixing
+      ENDIF
 
       !                                      ! Dynamics
Index: NEMO/branches/UKMO/NEMO_4.0_surge/src/OCE/step.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_surge/src/OCE/step.F90	(revision 11145)
+++ NEMO/branches/UKMO/NEMO_4.0_surge/src/OCE/step.F90	(revision 11180)
@@ -125,9 +125,11 @@
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       !  THERMODYNAMICS
+      IF ( .NOT. ln_2d ) THEN 
                          CALL eos_rab( tsb, rab_b )       ! before local thermal/haline expension ratio at T-points
                          CALL eos_rab( tsn, rab_n )       ! now    local thermal/haline expension ratio at T-points
                          CALL bn2    ( tsb, rab_b, rn2b ) ! before Brunt-Vaisala frequency
                          CALL bn2    ( tsn, rab_n, rn2  ) ! now    Brunt-Vaisala frequency
-
+      ENDIF
+      
       !  VERTICAL PHYSICS
                          CALL zdf_phy( kstp )         ! vertical physics update (top/bot drag, avt, avs, avm + MLD)
@@ -163,5 +165,5 @@
                             CALL wzv           ( kstp )  ! now cross-level velocity 
       IF( ln_zad_Aimp )     CALL wAimp         ( kstp )  ! Adaptive-implicit vertical advection partitioning
-                            CALL eos    ( tsn, rhd, rhop, gdept_n(:,:,:) )  ! now in situ density for hpg computation
+      IF( .NOT. ln_2d )     CALL eos    ( tsn, rhd, rhop, gdept_n(:,:,:) )  ! now in situ density for hpg computation
                             
 !!jc: fs simplification
@@ -202,5 +204,5 @@
       ENDIF
       
-                         CALL dyn_zdf       ( kstp )  ! vertical diffusion
+      IF( .NOT. ln_2d )     CALL dyn_zdf       ( kstp )  ! vertical diffusion
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -232,4 +234,5 @@
       ! Active tracers                              
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+      IF (.NOT. ln_2d) THEN  ! No tracers in 2D mode
                          tsa(:,:,:,:) = 0._wp         ! set tracer trends to zero
 
@@ -257,5 +260,6 @@
                          CALL tra_zdf       ( kstp )  ! vertical mixing and after tracer fields
       IF( ln_zdfnpc  )   CALL tra_npc       ( kstp )  ! update after fields by non-penetrative convection
-
+      ENDIF ! not ln_2d 
+      
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       ! Set boundary conditions and Swap
@@ -275,5 +279,5 @@
 !! 
 !!jc2: dynnxt must be the latest call. e3t_b are indeed updated in that routine
-                         CALL tra_nxt       ( kstp )  ! finalize (bcs) tracer fields at next time step and swap
+      IF (.NOT. ln_2d)   CALL tra_nxt       ( kstp )  ! finalize (bcs) tracer fields at next time step and swap
                          CALL dyn_nxt       ( kstp )  ! finalize (bcs) velocities at next time step and swap (always called after tra_nxt)
                          CALL ssh_swp       ( kstp )  ! swap of sea surface height
